#INCLUDE "rwmake.ch"
#Include "AP5Mail.ch"
/*/
͹
Descricao P.E. UTILIZADO NA GRAVACAO DO ORCAMENTO                     
          ENVIA WORKFLOW PARA O CLIENTE NOS CASOS DE INCL. E ALTER.   
͹
Uso        AP6 IDE                                                    
ͼ


/*/

User Function M415GRV()

Local nMoeda 	:= 0
Local aMens     := {} //{01-CODIGO,02-MENSAGEM}
Local nItem     := 0
Local nTotalQtd := 0
Local nTotalPed := 0
Local nTotalPrc := 0
Local nTotalIPI := 0
Local nTotalICM := 0
Local oHtml
Local cEmail := Space(30)
Local cCepPict:=PesqPict("SA1","A1_CEP")
Local cCGCPict:=PesqPict("SA1","A1_CGC")
Private cEmailVend

//VERIFICA A FUNCAO EM EXECUCAO PARA DAR CONTINUIDADE, PONTO DE ENTRADA COMUM A TODAS AS ROTINAS
If !ProcName(3)$"A415ALTERA|A415INCLUI|A415COPIA"
	Return
EndIf

//busca todos os dados do cabecalho
cQuery := " SELECT CJ_NUM,CJ_CLIENTE,CJ_LOJA,CJ_MOEDA, CJ_NUM, CJ_EMISSAO,E4_CODIGO, E4_DESCRI,"
cQuery += " A1_COD, A1_LOJA, A1_NOME,A1_CONTATO, A1_TEL, A1_END, A1_CEP,A1_FAX, A1_MUN,A1_EST, A1_CGC, A1_INSCR, A1_ENDENT,A1_CEPE,"
cQuery += " A1_ENDCOB,A1_CEPC,A1_MUNE,A1_ESTE,A1_MUNC,A1_ESTC, A1_EMAIL, A1_TIPO, A1_VEND"
cQuery += " FROM SCJ010 AS CJ"
cQuery += " INNER JOIN SA1010 AS A1"
cQuery += " ON CJ_CLIENTE = A1_COD AND CJ_LOJA = A1_LOJA"
cQuery += " INNER JOIN SE4010 AS E4"
cQuery += " ON E4_CODIGO = CJ_CONDPAG"
cQuery += " WHERE CJ.D_E_L_E_T_ <> '*' AND E4.D_E_L_E_T_ <> '*' AND A1.D_E_L_E_T_ <> '*' "
cQuery += " AND CJ_NUM = '"+SCJ->CJ_NUM+"'"


MemoWrit("M415END.sql",cQuery)
dbUseArea(.T.,"TOPCONN", TCGenQry(,,cQuery),"TRB", .F., .T.)
TcSetField("TRB","CJ_EMISSAO","D")

COUNT TO nRecCount
//CASO TENHA DADOS
If nRecCount > 0
	dbSelectArea("TRB")
	dbGoTop()
	//armazena o email do vendedor
	cEmailVend := Iif(!Empty(UsrRetMail(RetCodUsr())),UsrRetMail(RetCodUsr()),getMV(MV_WFADMIN))
		
	//caso nao encontre um e-mail
	cEmail := TRB->A1_EMAIL
	If Empty(cEmail)
		If MsgYesNo("O Cliente "+TRB->A1_COD+"-"+TRB->A1_NOME+" no tem um email cadsatrado, deseja cadastrar agora?")
			
			@ 100,153 To 329,435 Dialog oDlg Title OemToAnsi("Endereo de e-mail")
			@ 9,9 Say OemToAnsi("E-mail") Size 99,8
			@ 28,9 Get cEmail  Size 79,10
			
			@ 62,39 BMPBUTTON TYPE 1 ACTION Close(oDlg)
			
			Activate Dialog oDlg Centered
			//grava o email no SA1
			cQuery := " UPDATE SA1010 SET A1_EMAIL = '"+cEmail+"' WHERE A1_COD = '"+TRB->A1_COD+"' AND A1_LOJA = '"+TRB->A1_LOJA+"'
			MemoWrit("M415ENDu.sql",cQuery)
			TcSqlExec(cQuery)
		EndIf
	EndIf
	
	//Caso nao tenha cadastrado e-mail aborta a operacao
	If Alltrim(cEmail) == ""
		cCliMen  := TRB->CJ_CLIENTE +"-"+ TRB->A1_NOME
		MsgStop("Operao cancelada!")
		cMen := "O Cliente "+cCliMen+" no possui e-mail Cadastrado"
		ENVIAEMAIL(cMen)
		TRB->(dbCloseArea())
		Return
	EndIf
	
	//FUNCOES PARA ENVIO DE HTML
	oProcess:=TWFProcess():New("000002","Oramento de Vendas")
	oProcess:NewTask('Inicio',"\WORKFLOW\HTM\MATA415.htm")
	oHtml   := oProcess:oHtml
	
	
	dbSelectArea("TRB")
	dbGoTop()
	While !EOF()
		dbSelectArea("TRB")
		aMens := {}
		cCliente := TRB->CJ_CLIENTE
		cCliMen  := TRB->CJ_CLIENTE + TRB->A1_NOME
		cLojaCli := TRB->CJ_LOJA
		nMoeda   := TRB->CJ_MOEDA
		nOrcam   := TRB->CJ_NUM
		dEmiss   := TRB->CJ_EMISSAO
		nAcresc  := 0
		nAcresc  := 0
		tTransp  := ""
		
		oHtml:ValByName("cNumero", TRB->CJ_NUM) 					//numero do pedido
		
		//dados da empresa corrente
		oHtml:ValByName("cNomEmp", SM0->M0_NOMECOM)					//nome da empresa coorente
		oHtml:ValByName("cEnd"   , SM0->M0_ENDCOB)					//endereco
		oHtml:ValByName("cTel"	 , SM0->M0_TEL)						//telefone
		oHtml:ValByName("cMun"	 , SM0->M0_CIDCOB)					//municipio
		oHtml:ValByName("cEst"	 , SM0->M0_ESTCOB)					//Estado
		oHtml:ValByName("cCNPJ"	 , Transform(SM0->M0_CGC,cCgcPict))	//cnpj
		
		//dados do cliente
		oHtml:ValByName("cCliente" , TRB->A1_COD + " / " + TRB->A1_LOJA)		//codigo + loja
		oHtml:ValByName("cNomCli"  , TRB->A1_NOME)								//razao social do cliente
		oHtml:ValByName("cContato" , TRB->A1_CONTATO)							//conato
		oHtml:ValByName("cTelCli"  , TRB->A1_TEL)								//telefone
		oHtml:ValByName("cEndCli"  , TRB->A1_END)								//Endereco
		oHtml:ValByName("cCEPCli"  , transform( TRB->A1_CEP, "@R 99999-999" ))	//cep
		oHtml:ValByName("cFaxCli"  , TRB->A1_FAX)								//fax
		oHtml:ValByName("cMunCli"  , TRB->A1_MUN)								//municipio
		oHtml:ValByName("cEstCli"  , TRB->A1_EST)								//estado
		oHtml:ValByName("cCNPJCli" , Transform(TRB->A1_CGC,cCgcPict))			//cnpj
		oHtml:ValByName("cIECli"   , TRANSFORM(TRB->A1_INSCR ,"@R 999.999.999.999")) //inscricao estadual
		//dados da entrega
		oHtml:ValByName("cEndEnt"  , TRB->A1_ENDENT)								//endereco de entrega
		oHtml:ValByName("cCEPEnt"  , transform( TRB->A1_CEPE, "@R 99999-999" ))	//cep de entrega
		oHtml:ValByName("cMunEnt"  , TRB->A1_MUNE)								//municipio de entrega
		oHtml:ValByName("cEstEnt"  , TRB->A1_ESTE)								//estado de entrega
		oHtml:ValByName("cTelEnt"  , TRB->A1_TEL )								//telefone de entrega
		//dados da cobranca
		oHtml:ValByName("cEndCob"  , TRB->A1_ENDCOB)								//endereo de cobrana
		oHtml:ValByName("cCEPCob"  , transform( TRB->A1_CEPC, "@R 99999-999" ))	//cep de cobranca
		oHtml:ValByName("cMunCob"  , TRB->A1_MUNC)								//municipio de cobranca
		oHtml:ValByName("cEstCob"  , TRB->A1_ESTC)								//estado de cobranca
		oHtml:ValByName("cTelCob"  , TRB->A1_TEL)								//telefone de cobranca
		
		//dados adicionais
		oHtml:ValByName("cCondPg"  , TRB->E4_CODIGO)								//codigo cond. de pgto
		oHtml:ValByName("cDescPg"  , TRB->E4_DESCRI)								//descricao da cond. de pgto
		oHtml:ValByName("cAcresc"  , Transform(nAcresc,"@E 9.99")+"%")	            //acrescimo financeiro
		oHtml:ValByName("cMoeda"   , iif(nMoeda = 1,"Moeda: Real","Moeda: Dolar"))	//moeda do orcamento
		
		//le os itens do orcamento

			dbSelectArea("TMP1")
			dbGoTop()
			
			//Ŀ
			//Inicializa a funcao fiscal                   
			//
			MaFisSave()
			MaFisEnd()
			MaFisIni(TRB->A1_COD,;			// 1-Codigo Cliente/Fornecedor
			TRB->A1_LOJA,;			// 2-Loja do Cliente/Fornecedor
			"C",;								// 3-C:Cliente , F:Fornecedor
			"N",;				// 4-Tipo da NF
			TRB->A1_TIPO,;			// 5-Tipo do Cliente/Fornecedor
			MaFisRelImp("MTR700",{"SCJ","SCK"}),;// 6-Relacao de Impostos que suportados no arquivo
			Nil,;							// 7-Tipo de complemento
			Nil,;							// 8-Permite Incluir Impostos no Rodape .T./.F.
			Nil,;					// 9-Alias do Cadastro de Produtos - ("SBI" P/ Front Loja)
			"MATA461")					// 10-Nome da rotina que esta utilizando a funcao
			
			
			//monta matriz dos itens
			oHtml:ValByName("it.it"      , {})
			oHtml:ValByName("it.cProduto"      , {})
			oHtml:ValByName("it.cDesc"      , {})
			oHtml:ValByName("it.cUM"      , {})
			oHtml:ValByName("it.cTes"      , {})
			oHtml:ValByName("it.cQtdVen"      , {})
			oHtml:ValByName("it.cPrcVen"      , {})
			oHtml:ValByName("it.cValor"      , {})
			oHtml:ValByName("it.cPIPI"      , {})
			oHtml:ValByName("it.cVIPI"      , {})
			oHtml:ValByName("it.cVICMS"      , {})
			oHtml:ValByName("it.cPICMS"      , {})
			oHtml:ValByName("it.cTotItem"      , {})
			oHtml:ValByName("it.cEnteg"      , {})
			
			While !EOF()
				dbSelectArea("TMP1")
				
				//grava o ID do workflow
				dbSelectArea("SCK")
				dbSetOrder(1)
				dbSeek(xFilial()+TRB->CJ_NUM+TMP1->CK_ITEM+TMP1->CK_PRODUTO)
				RecLock("SCK",.F.)
				CK_WFID := oProcess:fProcessID
				MsUnlock()
				
				nItem ++ //conta os itens
				MaFisAdd(TMP1->CK_PRODUTO,; 					// 1-Codigo do Produto ( Obrigatorio )
				TMP1->CK_TES,;					  			// 2-Codigo do TES ( Opcional )
				TMP1->CK_QTDVEN,;				  					// 3-Quantidade ( Obrigatorio )
				TMP1->CK_PRCVEN,;									// 4-Preco Unitario ( Obrigatorio )
				0,;							                		// 5-Valor do Desconto ( Opcional )
				"",;							  	  					// 6-Numero da NF Original ( Devolucao/Benef )
				"",;								  					// 7-Serie da NF Original ( Devolucao/Benef )
				0,;					              					// 8-RecNo da NF Original no arq SD1/SD2
				0,;							  						// 9-Valor do Frete do Item ( Opcional )
				0,;							  						// 10-Valor da Despesa do item ( Opcional )
				0,;            				  						// 11-Valor do Seguro do item ( Opcional )
				0,;							  						// 12-Valor do Frete Autonomo ( Opcional )
				TMP1->CK_VALOR,;											// 13-Valor da Mercadoria ( Obrigatorio )
				0,;							  						// 14-Valor da Embalagem ( Opiconal )
				0,;		     				  						// 15-RecNo do SB1
				0) 							  						// 16-RecNo do SF4
				//icms
				nALIQICM := MaFisRet(nItem,"IT_ALIQICM")
				nValIcm  := MaFisRet(nItem,"IT_VALICM")
				
				//calcula o IPI
				nValorIPI := TMP1->CK_VALOR * (Posicione("SB1",1,xFilial("SB1")+TMP1->CK_PRODUTO,"B1_IPI") / 100)
				//soma o total do item
				nTotIt    := TMP1->CK_VALOR + nValorIPI
				
				//itens do orcamento
				aadd(oHtml:ValByName("it.it")      , TMP1->CK_ITEM)
				aadd(oHtml:ValByName("it.cProduto"), TMP1->CK_PRODUTO)
				aadd(oHtml:ValByName("it.cDesc")   , SubStr(Posicione("SB1",1,xFilial("SB1")+TMP1->CK_PRODUTO,"B1_DESC"),1,38))
				aadd(oHtml:ValByName("it.cUM")     , Posicione("SB1",1,xFilial("SB1")+TMP1->CK_PRODUTO,"B1_UM"))
				aadd(oHtml:ValByName("it.cTes")    , TMP1->CK_TES)
				aadd(oHtml:ValByName("it.cQtdVen") , Transform(TMP1->CK_QTDVEN,"@E 999,999"))
				aadd(oHtml:ValByName("it.cPrcVen") , Transform(TMP1->CK_PRCVEN,"@E 999,999.99"))
				aadd(oHtml:ValByName("it.cValor")  , Transform(TMP1->CK_VALOR,"@E 9,999.99"))
				aadd(oHtml:ValByName("it.cPIPI")   , Transform(Posicione("SB1",1,xFilial("SB1")+TMP1->CK_PRODUTO,"B1_IPI"),"@E 99.99")+"%")
				aadd(oHtml:ValByName("it.cVIPI")   , Transform(nValorIPI,"@E 9,999.99"))
				aadd(oHtml:ValByName("it.cVICMS")  , Transform(nValIcm,"@E 9,999.99"))
				aadd(oHtml:ValByName("it.cPICMS")  , Transform(nALIQICM,"@E 99.99")+"%")
				aadd(oHtml:ValByName("it.cTotItem"), Transform(nTotIt,"@E 9,999.99"))
				aadd(oHtml:ValByName("it.cEntreg"), TMP1->CK_ENTREG)
				//soma os totais
				
				nTotalQtd := nTotalQtd     + TMP1->CK_QTDVEN
				nTotalPrc := nTotalPrc     + TMP1->CK_VALOR
				nTotalIPI := nTotalIPI     + nValorIPI
				nTotalICM := nTotalICM     + nValIcm
				nTotalPed := nTotalPed     + nTotIt

				dbSelectArea("TMP1")
				dbSkip()

			EndDo
        TMP1->(DBGOTOP())
		MaFisEnd()
		//totais do orcamento
		oHtml:ValByName("cTotalQtd"  , Transform(nTotalQtd,"@E 9,999,999"))			//quantidade
		oHtml:ValByName("cTotalPrc"  , Transform(nTotalPrc,"@E 9,999,999.99"))		//valor unitario
		oHtml:ValByName("cTotalIPI"  , Transform(nTotalIPI,"@E 99,999.99"))        //IPI
		oHtml:ValByName("cTotalICM"  , Transform(nTotalICM,"@E 99,999.99"))			//ICMS
		oHtml:ValByName("cTotalPed"  , Transform(nTotalPed,"@E 9,999,999.99"))		//total geral
		
		
		dbSelectArea("TRB")
		dbSkip()
	End
	
	oProcess:cTo      := cEmail
	oProcess:cBCC     := ''
	oProcess:cSubject := "Processo de Oramento de Vendas" + SCJ->CJ_NUM
	oProcess:cBody    := ""
	oProcess:bReturn  := "U_M415GRVR(1)"
	oProcess:Start()
	//RastreiaWF( ID do Processo, Codigo do Processo, Codigo do Status, Descricao Especifica, Usuario )
	RastreiaWF(oProcess:fProcessID+'.'+oProcess:fTaskID,"000002",'1003',"Email Enviado Para o Cliente:"+TRB->A1_NOME,cUsername)
	WFSendMail()
	cProc := Lower(oProcess:fProcessID)
	DelWkf(cProc)
	cMen := "Oramento "+SCJ->CJ_NUM+" enviado ao cliente "+cCliMen+" no e-mail "+cEmail+""
	ENVIAEMAIL(cMen)
	
EndIf


TRB->(dbCloseArea())

Return

/*


ͻ
Programa  ENVIAEMAILAutor  Microsiga            Data   12/12/03   
͹
Desc.                                                                 
                                                                      
͹
Uso        AP                                                        
ͼ


*/

Static Function ENVIAEMAIL(cMen)

Local lResult   := .f.				// Resultado da tentativa de comunicacao com servidor de E-Mail
Local cTitulo1
Local lRelauth := GetNewPar("MV_RELAUTH",.F.)		// Parametro que indica se existe autenticacao no e-mail
Local cEmailTo
Local cEmailBcc:= ""
Local cError   := ""
Local lRelauth := GetNewPar("MV_RELAUTH",.F.)		// Parametro que indica se existe autenticacao no e-mail
Local lRet	   := .F.
Local cFrom	   := GetMV("MV_RELACNT")
Local cConta   := GetMV("MV_RELACNT")
Local cSenha   := GetMV("MV_RELPSW")

cEmailTo := cEmailVend
cTitulo1:= "Oramento de Vendas"
cMensagem:= cMen


//Ŀ
// Tenta conexao com o servidor de E-Mail 
//
CONNECT SMTP                         ;
SERVER 	 GetMV("MV_RELSERV"); 	// Nome do servidor de e-mail
ACCOUNT  GetMV("MV_RELACNT"); 	// Nome da conta a ser usada no e-mail
PASSWORD GetMV("MV_RELPSW") ; 	// Senha
RESULT   lResult             	// Resultado da tentativa de conexo

// Se a conexao com o SMPT esta ok
If lResult
	
	// Se existe autenticacao para envio valida pela funcao MAILAUTH
	If lRelauth
		lRet := Mailauth(cConta,cSenha)
	Else
		lRet := .T.
	Endif
	
	If lRet
		SEND MAIL FROM 	cFrom ;
		TO 				cEmailTo;
		BCC     		cEmailBcc;
		SUBJECT 		cTitulo1;
		BODY 			cMensagem;
		RESULT lResult
		
		
		If !lResult
			//Erro no envio do email
			GET MAIL ERROR cError
			Help(" ",1,"ATENCAO",,cError+ " " + cEmailTo,4,5)	//STR0006
		Endif
		
	Else
		GET MAIL ERROR cError
		Help(" ",1,"Autenticacao",,cError,4,5)
		MsgStop("Erro de autenticao","Verifique a conta e a senha para envio")
	Endif
	
	DISCONNECT SMTP SERVER
Else
	//Erro na conexao com o SMTP Server
	GET MAIL ERROR cError
	Help(" ",1,"Atencao",,cError,4,5)
Endif

Return
/*


ͻ
Programa  RCFGE50   Autor  Microsiga            Data   12/11/05   
͹
Desc.                                                                 
                                                                      
͹
Uso        AP                                                        
ͼ


*/
Static Function DelWkf(cProc)

cFindKey := Left( cProc + ".01" + Space( 100 ),100 )

dbSelectArea( "WF3" )
dbSetOrder( 1 )

if dbSeek(xFilial()+ cFindKey )
	While !EOF() .And. cFindKey == WF3_ID
		cProcCode := WF3_PROC
		If AllTrim(WF3_STATUS) == "000099"
			if RecLock( "WF3",.T. )
				dbDelete()
				MSUnlock("WF3")
			end
		EndIf
		dbSkip()
	End
	
end

Return


/*
͹
Desc.     Retorno do workflow de orcamento                            
                                                                      
͹
Uso        AP                                                         
ͼ


*/
User Function M415GRVR(nOpcao,oProc)
Local aCab  := {}
Local aItem
Local nOpc  := 3
Local oHtml
Local cItSC6 	:= "00"
Local nContErro := 0
Local aItePv 	:={}
Private cEmailVend
Private cEmailAdm
// Orcamento recebido e parametro ativado
If oProc:oHtml:RetByName("Aprovacao") = "S" .And. GetMV("MV_E_GRPV")=="S"
	//monta o cabecalho do pedido
	cNUM     := oProc:oHtml:RetByName("cNumero")
	cPed  := GetSx8Num("SC5","C5_NUM")
	
	dbSelectArea("SCJ")
	dbSetOrder(1)
	If dbSeek(xFilial()+cNum)
		
		dbSelectArea("SA1")
		dbSetOrder(1)
		dbSeek(xFilial()+SCJ->CJ_CLIENTE+SCJ->CJ_LOJA)
		
		aAdd(aCab ,{"C5_NUM",		cPed			,NIL})
		aAdd(aCab ,{"C5_TIPO",		"N"				,NIL})
		aAdd(aCab ,{"C5_CLIENTE",	SCJ->CJ_CLIENTE	,NIL})
		aAdd(aCab ,{"C5_LOJAENT",	SCJ->CJ_LOJAENT	,NIL})
		aAdd(aCab ,{"C5_LOJACLI",	SCJ->CJ_LOJA	,NIL})
		aAdd(aCab ,{"C5_CONDPAG",	SCJ->CJ_CONDPAG	,NIL})
		aAdd(aCab ,{"C5_TABELA",	SCJ->CJ_TABELA	,NIL})
		aAdd(aCab ,{"C5_VEND1",		SCJ->CJ_E_VND1 	,NIL})
//		aAdd(aCab ,{"C5_NATUREZ",	SA1->A1_NATUREZ	,NIL})
		aAdd(aCab ,{"C5_EMISSAO",	SCJ->CJ_EMISSAO	,NIL})
		aAdd(aCab ,{"C5_TIPOCLI",	SA1->A1_TIPO	,NIL})
		aAdd(aCab ,{"C5_CLIENT",	SCJ->CJ_CLIENT	,NIL})
		aAdd(aCab ,{"C5_TRANSP",	SA1->A1_TRANSP	,NIL})
		aAdd(aCab ,{"C5_TPFRETE",	SA1->A1_TPFRET	,NIL})
		aAdd(aCab ,{"C5_FRETE",		SCJ->CJ_FRETE	,NIL})
		aAdd(aCab ,{"C5_COMIS1",	SA1->A1_COMIS	,NIL})
		aAdd(aCab ,{"C5_MOEDA",		SCJ->CJ_MOEDA	,NIL})
		aAdd(aCab ,{"C5_TXMOEDA",	SCJ->CJ_TXMOEDA	,NIL})
		aAdd(aCab ,{"C5_TIPLIB",	SCJ->CJ_TIPLIB	,NIL})
		
	Else
		Return
	EndIf
	//monta os itens do pedido
	dbSelectArea("SCK")
	dbSetOrder(1)
	dbSeek(xFilial()+cNum)
	While !EOF() .And. cNum == SCK->CK_NUM
		aItem :={}
		dbSelectArea("SB1")
		dbSetOrder(1)
		dbSeek(xFilial()+SCK->CK_PRODUTO)
		
		cItSC6 := Soma1(cItSC6) //item do pedido
		//calcula o cfo
		aDadosCfo := {}
		Aadd(aDadosCfo,{"OPERNF","S"})
		Aadd(aDadosCfo,{"TPCLIFOR",SA1->A1_TIPO})
		Aadd(aDadosCfo,{"UFDEST",SA1->A1_EST})
		Aadd(aDadosCfo,{"INSCR" ,SA1->A1_INSCR})
		
		
		aAdd(aItem,{"C6_NUM"		,  	cPed		   						,NIL})
		aAdd(aItem,{"C6_ITEM"		,	cItSC6		   						,NIL})
		aAdd(aItem,{"C6_PRODUTO"	,	SCK->CK_PRODUTO						,NIL})
		aAdd(aItem,{"C6_QTDVEN"		,	SCK->CK_QTDVEN						,NIL})
		aAdd(aItem,{"C6_PRCVEN"		,	SCK->CK_PRCVEN						,NIL})
		aAdd(aItem,{"C6_VALOR"		,	SCK->CK_VALOR			 			,NIL})
		aAdd(aItem,{"C6_ENTREG"		,	SCK->CK_ENTREG						,NIL})
		aAdd(aItem,{"C6_UM"			,	SB1->B1_UM							,NIL})
		aAdd(aItem,{"C6_TES"		,	SCK->CK_TES							,NIL})
		aAdd(aItem,{"C6_LOCAL"		,	SCK->CK_LOCAL						,NIL})
		aAdd(aItem,{"C6_DESCRI"		,	SCK->CK_DESCRI						,NIL})
		aAdd(aItem,{"C6_CF"			,	MaFisCfo(,SF4->F4_CF,aDadosCfo)		,NIL})
		aAdd(aItem,{"C6_CLI"		,	SCK->CK_CLIENTE						,NIL})
		aAdd(aItem,{"C6_LOJA"		,	SCK->CK_LOJA						,NIL})
		aAdd(aItem,{"C6_VALDESC"	,	SCK->CK_VALDESC						,NIL})
		aAdd(aItem,{"C6_DESCONT"	,	SCK->CK_DESCONT						,NIL})
		aAdd(aItem,{"C6_PEDCLI"		,	SCK->CK_PEDCLI						,NIL})
		aAdd(aItem,{"C6_PRUNIT"		,	SCK->CK_PRUNIT	 					,NIL})
		aAdd(aItem,{"C6_NUMORC"		,	SCK->CK_NUM+SCK->CK_ITEM			,NIL})
		aAdd(aItem,{"C6_OPC"   		,	SCK->CK_OPC							,NIL})
		aAdd(aItem,{"C6_OBS"   		,	SCK->CK_OBS							,NIL})
		aAdd(aItem,{"C6_CLASFIS"	,	SCK->CK_CLASFIS						,NIL})
		aAdd(aItem,{"C6_QTDLIB"  	,	0									,NIL})
		aAdd(aItem,{"C6_COMIS"		,	0									,NIL})
		aAdd(aItePv,aItem)
		//CRIA O SB2 CASO NAO EXISTA
		dbSelectArea("SB2")
		dbSetOrder(1)
		If !MsSeek(xFilial("SB2")+SCK->CK_PRODUTO+SCK->CK_LOCAL)
			CriaSB2(SCK->CK_PRODUTO,SCK->CK_LOCAL)
		EndIf
		
		dbSelectArea("SCK")
		dbSkip()
	End
	//inicio da transacao
	Begin Transaction
	
	lMsErroAuto := .F.
	//grava o pedido
	MSExecAuto({|x,y,z|Mata410(x,y,z)},aCab,aItePv,3)
	//MATA410(aCab,aItem)
	If lMsErroAuto
		nContErro ++
		RollBackSX8()
	Else
		ConfirmSX8()
		
	EndIf
	End Transaction
	//Ŀ
	// Se gerou novo arquivo de erro, apaga o anterior e gera novo  
	//
	If nContErro > 0
		cNomArqErro := NomeAutoLog()
		cNomNovArq  := __RELDIR+"TITULOG.##R"
		If MsErase(cNomNovArq)
			__CopyFile(cNomArqErro,cNomNovArq)
		EndIf
		MsErase(cNomArqErro)
		//dados para o email quando houver erro
		cMen := "Houve um erro na efetivao do Oramento "+SCJ->CJ_NUM+" do Cliente "+SA1->A1_NOME+". Favor gerar o pedido manualmente"
		cEmailVend := Posicione("SA3",1,xFilial("SA3")+SCJ->CJ_E_VND1,"A3_EMAIL")
		cEmailVend := IIf(!Empty(cEmailVend),cEmailVend,GetMV("MV_WFADMIN"))+";"+GetMV("MV_WFADMIN")
		EnvMail(cMen)
		Return
	EndIf
	//envia email para o vendedor avisando que foi gerado o pedido
	cMen := "O Oramento "+SCJ->CJ_NUM+" do Cliente "+SA1->A1_NOME+" foi efetivado com sucesso e gerou o Pedido "+cPed
	cEmailVend := Posicione("SA3",1,xFilial("SA3")+SCJ->CJ_E_VND1,"A3_EMAIL")
	cEmailVend := IIf(!Empty(cEmailVend),cEmailVend,GetMV("MV_WFADMIN"))
	EnvMail(cMen)
	//Ŀ
	// Atualiza o status do orcamento - Baixa                                 
	//
	dbSelectArea("SCJ")
	RecLock("SCJ",.F.)
	MaAvalOrc("SCJ",13)
	SCJ->CJ_STATUS := "B"
	MsUnlock()
	
	dbSelectArea("SCK")
	dbSetOrder(1)
	dbSeek(xFilial()+cNum)
	While !EOF() .And. CK_NUM == cNum
		RecLock("SCK",.F.)
		SCK->CK_NUMPV := cPed
		MaAvalOrc("SCJ",3)
		MsUnLock()
		dbSkip()
	End
ElseIf oProc:oHtml:RetByName("Aprovacao") = "S" .And. GetMV("MV_E_GRPV")=="N"
	//envia email para o vendedor avisando que o orcamento foi aprovado
	cNUM     := oProc:oHtml:RetByName("cNumero")
	dbSelectArea("SCJ")
	dbSetOrder(1)
	dbSeek(xFilial()+cNum)
	
	cMen := "O Oramento "+SCJ->CJ_NUM+" do Cliente "+SA1->A1_NOME+" foi aprovado"
	cEmailVend := Posicione("SA3",1,xFilial("SA3")+SCJ->CJ_E_VND1,"A3_EMAIL")
	cEmailVend := IIf(!Empty(cEmailVend),cEmailVend,GetMV("MV_WFADMIN"))
	EnvMail(cMen)
Else
	//envia email para o vendedor avisando que o orcamento foi rejeitado
	cNUM     := oProc:oHtml:RetByName("cNumero")
	
	dbSelectArea("SCJ")
	dbSetOrder(1)
	dbSeek(xFilial()+cNum)
	
	cMen := "O Oramento "+SCJ->CJ_NUM+" do Cliente "+SA1->A1_NOME+" foi rejeitado pelo motivo:"+CHR(13)+CHR(10)
	cMen += oProc:oHtml:RetByName("CJ_Obs")
	cEmailVend := Posicione("SA3",1,xFilial("SA3")+SCJ->CJ_E_VND1,"A3_EMAIL")
	cEmailVend := IIf(!Empty(cEmailVend),cEmailVend,GetMV("MV_WFADMIN"))
	EnvMail(cMen)
EndIf


Return


/*


ͻ
Programa  ENVMAIL   Autor  Microsiga            Data   12/12/03   
͹
Desc.                                                                 
                                                                      
͹
Uso        AP                                                         
ͼ


*/

Static Function ENVMAIL(cMen)

Local lResult   := .f.				// Resultado da tentativa de comunicacao com servidor de E-Mail
Local cTitulo1
Local lRelauth := GetNewPar("MV_RELAUTH",.F.)		// Parametro que indica se existe autenticacao no e-mail
Local cEmailTo
Local cEmailBcc:= ""
Local cError   := ""
Local lRelauth := GetNewPar("MV_RELAUTH",.F.)		// Parametro que indica se existe autenticacao no e-mail
Local lRet	   := .F.
Local cFrom	   := GetMV("MV_RELACNT")
Local cConta   := GetMV("MV_RELACNT")
Local cSenha   := GetMV("MV_RELPSW")

cEmailTo := cEmailVend
cTitulo1:= "Oramento de Vendas"
cMensagem:= cMen


//Ŀ
// Tenta conexao com o servidor de E-Mail 
//
CONNECT SMTP                         ;
SERVER 	 GetMV("MV_RELSERV"); 	// Nome do servidor de e-mail
ACCOUNT  GetMV("MV_RELACNT"); 	// Nome da conta a ser usada no e-mail
PASSWORD GetMV("MV_RELPSW") ; 	// Senha
RESULT   lResult             	// Resultado da tentativa de conexo

// Se a conexao com o SMPT esta ok
If lResult
	
	// Se existe autenticacao para envio valida pela funcao MAILAUTH
	If lRelauth
		lRet := Mailauth(cConta,cSenha)
	Else
		lRet := .T.
	Endif
	
	If lRet
		SEND MAIL FROM 	cFrom ;
		TO 				cEmailTo;
		BCC     		cEmailBcc;
		SUBJECT 		cTitulo1;
		BODY 			cMensagem;
		RESULT lResult
		
		
		If !lResult
			//Erro no envio do email
			GET MAIL ERROR cError
			Help(" ",1,"ATENCAO",,cError+ " " + cEmailTo,4,5)	//STR0006
		Endif
		
	Else
		GET MAIL ERROR cError
		Help(" ",1,"Autenticacao",,cError,4,5)
		MsgStop("Erro de autenticao","Verifique a conta e a senha para envio")
	Endif
	
	DISCONNECT SMTP SERVER
Else
	//Erro na conexao com o SMTP Server
	GET MAIL ERROR cError
	Help(" ",1,"Atencao",,cError,4,5)
Endif

Return
